// ---------------------------------------------------------------------------
// announce.cs -- Version 1.7 -- December 31, 2000
// by Lorne Laliberte (writer@planetstarsiege.com)
//
// Automated messages to keep your teammates informed
//
// http://www.writerscripts.com
// ---------------------------------------------------------------------------

include("writer\\version.cs");
version("writer\\announce.cs", "1.7", "Lorne Laliberte", "Dec 31, 2000");

include("writer\\event.cs");
include("writer\\flood.cs");
include("writer\\inventory.cs");
include("writer\\modifier.cs");
include("writer\\schedule.cs");
include("writer\\repair_events.cs");
include("writer\\save.cs");
include("writer\\station_events.cs");
include("writer\\whatif.cs");

// Include Presto's Chores.cs (for the Job::Do() function) only if necessary
if( ($PrestoPref::JobMenu != "") && ($PrestoPref::JobMenu != "false") )
    include("presto\\Chores.cs");


// ---------------------------------------------------------------------------
// DEFAULT SETTINGS:
//
// Edit these if you're running this script for the first time
// All subsequent settings must be done in the config\wp_announce.cs file

    // Key you can hold to prevent any anouncements
    // I recommend using a modifier like "lshift" for this
    $Announce::OverrideHoldKey = "";


// -- Armor:


    // Announce what armor you're wearing after you exit an inventory station
    // and you're wearing different armor or carrying a different loadout
    $Announce::ArmorChange = "true";

    // Toggle ArmorChange on/off from within Tribes
    //bind(keyboard0, make, alt, "whatever", TO, "Announce::ArmorChange::Toggle();");
    //bind(keyboard0, break, alt, "whatever", TO, "", Announce::ArmorChange::Toggle_break);


// -- Carrying:


    // Announce what you're carrying when you exit a station
    $Announce::Carrying = "true";

    // Messages (including ~job: strings for Presto's TeamHUD) to be used when
    // you exit an inventory station carrying the specified item -- use "mute"
    // if you don't want to say anything when you're carrying that item
    Announce::Carrying("Turret", "Deploying Turrets~job:iam-depl-dtur");
    Announce::Carrying("Inventory Station", "Carrying an Inventory Station~job:iam-depl-dinv");
    Announce::Carrying("Ammo Station", "Carrying an Ammo Station~job:iam-depl-dammo");
    Announce::Carrying("Motion Sensor", "Deploying Sensors~job:iam-depl-dsen");
    Announce::Carrying("Pulse Sensor", "Deploying Sensors~job:iam-depl-dsen");
    Announce::Carrying("Sensor Jammer", "Deploying Jammers~job:iam-depl-djam");
    Announce::Carrying("Camera", "Deploying Cameras~job:iam-depl-dcam");
    Announce::Carrying("Energy Pack", "mute");
    Announce::Carrying("Ammo Pack", "mute");
    Announce::Carrying("Shield Pack", "mute");
    Announce::Carrying("Sensor Jammer Pack", "mute");

    // Announce you're carrying any other items (that you haven't listed above)
    $Announce::CarryingOther = "false";

    // Number of seconds before you announce you're carrying the same thing
    $Announce::Carrying::FloodTime = "45";

    // Toggle Announce Carrying on/off from within Tribes
    //bind(keyboard0, make, alt, "whatever", TO, "Announce::Carrying::Toggle();");
    //bind(keyboard0, break, alt, "whatever", TO, "", Announce::Carrying::Toggle_break);


// -- Deployed:


    // Announce what you've deployed
    $Announce::Deployed = "true";

    // Messages (including ~job: strings for Presto's TeamHUD) to be used when you deploy the specified item
    Announce::Deployed("Inventory Station", "Inventory Station deployed~job:fin-depl-dinv");
    Announce::Deployed("Ammo Station", "Ammo Station deployed~job:fin-depl-dammo");

    // Announce you're deploying any other items (that you haven't listed above)
    $Announce::DeployedOther = "true";

    // Time in seconds before you announce you're deploying the same thing
    $Announce::Deployed::FloodTime = "30";

    // Toggle Announce Deployed on/off from within Tribes
    //bind(keyboard0, make, alt, "whatever", TO, "Announce::Deployed::Toggle();");
    //bind(keyboard0, break, alt, "whatever", TO, "", Announce::Deployed::Toggle_break);


// -- Thanks:


    // Say a thank you message when repaired
    $Announce::ThankYouMessage = "false";

    // Play the local sound "Thanks" when repaired
    $Announce::ThankYouSound = "true";

    // Delay, in seconds, before saying thanks when repaired
    $Announce::ThankYouDelay = "1";


// -- Stations:


    // Report damaged stations
    $Announce::StationIsDown = "true";

    // Message used when you try to access a damaged station
   $Announce::StationIsDown::string = "Stations need repairs!~job:need-rep-stat~wneedrep";


// -- Power:


    // Report power outtages
    $Announce::PowerIsDown = "true";

    // Message used when you try to access a station and the power is down
    $Announce::PowerIsDown::string = "Our Power is Down!~job:need-rep-gen~wneedrep";

    // Message used when you manually trigger the PowerRestored event
    $Announce::PowerRestored::string = "Our Power is Back Up!~wcheer1";

    // Message used when you complete repairs to a generator or solar panel
    // and the power was down
    $Announce::PowerRepaired::string = "Our Power is Back Up!~wcheer1";

    // Say a thank you message when someone else announces they've restored power
    $Announce::ThankPowerFixers = "false";

    // Message used when someone else announces repairs to solar panel or gens
    $Announce::ThankPowerFixers::string = "Thanks for restoring power!~wthanks";

    // Automatically trigger eventPowerRestored when you enter a station after
    // the power has been restored.
    $Announce::AutoTriggerPowerRestored = "false";

    // Message used when you access a station and the power has been restored
    $Announce::AutoPowerRestored::string = "Our Power is Back Up!~wthanks";

    // Manually trigger eventPowerRestored and tell your teammates the power is back up
    //bind(keyboard0, make, l_alt, "r", to, "Announce::PowerRestored();");
    //bind(keyboard0, break, l_alt, "r", to, "", "Announce::PowerRestored");


// -- Repairs:


    // Don't inform your team about repairing certain ("filtered") items
    $Announce::FilterRepairs = "true";

    // Keep quiet about repairs on these ("filtered") items
    Announce::FilterItem("Scout");
    Announce::FilterItem("LPC");
    Announce::FilterItem("HPC");

    // Same as above, but allows you to filter based on partial strings
    Announce::FilterAnyNameWith("remote"); // filters any item with "remote" in the name
    Announce::FilterAnyNameWith("RMT"); // filters any item with "RMT" in the name

    // Notify your team on beginning repairs
    $Announce::RepairBegun = "true";

    // Message used when you begin repairs
    // Use %1 for the name of the item you're repairing
    $Announce::RepairBegun::string = "Repair begun on %1";

    // Notify your team on completing repairs
    $Announce::RepairDone = "true";

    // Seconds before you'll announce beginning repairs on the same thing
    // after a repair is interrupted
    $Announce::RepairStopped::FloodTime = "30";

    // Seconds before you'll announce completing repairs on the same thing
    $Announce::RepairDone::FloodTime = "30";

    // Message used when you complete repairs on an item.
    // Use %1 for the name of the item you've repaired
    $Announce::RepairDone::string = "%1 has been repaired!~job:fin-rep";

    // Tell an antsy teammate to sit still for repairs
    $Announce::HoldPositionMessage = "false";

    // Play the local sound "wait" to tell an antsy teammate to sit still for repairs
    $Announce::HoldPositionSound = "true";

    // Message used when a player you're repairing moves, interrupting the repair.
    // Use %1 for the name of the player you're repairing
    $Announce::HoldPosition::string = "%1, hold position to be repaired.";

    // Toggle repair message filtering on/off
    //bind(keyboard0, make, alt, "whatever", TO, "Announce::FilterMode::Toggle();");
    //bind(keyboard0, break, alt, "whatever", TO, "", Announce::FilterMode::Toggle_break);

// ---------------------------------------------------------------------------

WriterPrefs::load("announce");

// Don't use Presto's TeamHUD functions unless the user has the jobmenu enabled
$Announce::UseJobDo = ($PrestoPref::JobMenu != "") && ($PrestoPref::JobMenu != "false") && included("presto\\Chores.cs");


// Automatically notify your teammates when you set out to deploy an item,
// unless you already set out to deploy that kind of item within the last
// 2 minutes.  Also notify your teammates whenever you deploy an item.
//
// Updates your job status for anyone using Presto's TeamHUD, even if you
// aren't using it yourself.
//
function Announce::Carrying()
{
    if($Modifier::Pressed[$Announce::OverrideHoldKey])
        return;

    %itemname = $Inv::Name[getMountedItem(1)];
    %carrymsg = $Announce::Carrying[%itemname];

    if(%carrymsg == mute || %itemname == "")
        return;

    if(%carrymsg == "")
    {
        if($Announce::CarryingOther)
            %carrymsg = "Carrying " @ %itemname;
        else
            return;
    }

    if($Announce::UseJobDo)
    {
        if( (%pos = String::findSubStr(%carrymsg, "~job:")) != -1)
        {
            %text = String::getSubStr(%carrymsg, 0, %pos);
            %job = String::getSubStr(%carrymsg, %pos + 5, 1024);

			if(Flood::Protect(%text, $Announce::Carrying::FloodTime))
                Job::Do(%text, %job);

            return;
        }
    }

	if(Flood::Protect(%carrymsg, $Announce::Carrying::FloodTime))
        say(1, %carrymsg);

    return;
}


function Announce::onDeployed(%itemtype, %itemname, %msg)
{
    if($Modifier::Pressed[$Announce::OverrideHoldKey])
        return;

    %deploymsg = $Announce::Deployed[%itemname];

    if(%deploymsg == mute)
        return true;

    if(%deploymsg == "")
        %deploymsg = %msg;

    if($Announce::UseJobDo)
    {
        if( (%pos = String::findSubStr(%deploymsg, "~job:")) != -1)
        {
            %text = String::getSubStr(%deploymsg, 0, %pos);
            %job = String::getSubStr(%deploymsg, %pos + 5, 1024);

			if(Flood::Protect(%text, $Announce::Deployed::FloodTime))
                Job::Do(%text, %job);

            return;
        }
    }

	if(Flood::Protect(%deploymsg, $Announce::Deployed::FloodTime))
        say(1, %deploymsg);

    return;
}


// Thank teammate (or enemy lol :) for repairing you
//
function Announce::onBeingRepairedBy(%name)
{
    if(Flood::protect("thanks" @ %name, 30))
    {
        // Be polite. :)
        if($Announce::ThankYouMessage && !$Modifier::Pressed[$Announce::OverrideHoldKey])
            schedule("say(1, \"Thanks " @ %name @ "!\");", $Announce::ThankYouDelay); // only visible to your team

        if($Announce::ThankYouSound)
            schedule("localMessage(\"thanks\");", $Announce::ThankYouDelay); // play local sound, only audible to those nearby
    }
    return;
}


function Announce::onPowerRestored()
{
    if(!$Announce::ManualPowerRestoredEvent)
        schedule::add("say(1, $Announce::AutoPowerRestored::string);", 1);

    return;
}

function Announce::onRemoteInventoryStation()
{
    schedule::cancel("say(1, $Announce::AutoPowerRestored::string);");
    return;
}


function Announce::onPowerIsDown()
{
    if($Modifier::Pressed[$Announce::OverrideHoldKey])
        return;

    // Tell teammates power is down if we haven't already done so in the last 30 seconds
    if(Flood::protect("Unit is not powered", 30))
        say(1, $Announce::PowerIsDown::string);

    return;
}


function Announce::onOtherPlayerRestoredPower(%itemstring, %itemroot)
{
    if($Announce::ThankPowerFixers)
        say(1, $Announce::ThankPowerFixers::string);

    return;
}


// Manually trigger eventPowerRestored
//
function Announce::PowerRestored()
{
    say(1, $Announce::PowerRestored::string);

    $Announce::ManualPowerRestoredEvent = true;
    Event::Trigger(eventPowerRestored);
    $Announce::ManualPowerRestoredEvent = false;

    $PowerWasDown = false;
    return;
}


function Announce::onRepairBegun(%itemstring, %itemroot)
{
    // Some people don't like hearing when I repair certain things --
    // as important as I think it is they know I'm repairing my trusty
    // scout, I try to be accomodating :)
    $Announce::Filter = $Announce::FilterRepairs && $Announce::FilterItem[%itemroot];

echo(%itemstring);

    for(%i = 0; %i < $Announce::FilterAnyNameWith::count; %i++)
    {
        if(String::findSubStr(%itemstring, $Announce::FilterAnyNameWith[%i]) != -1)
        {
            $Announce::Filter = true;
            break;
        }
    }

    if($Modifier::Pressed[$Announce::OverrideHoldKey])
        return;

    if($Announce::RepairBegun)
    {
        if(Flood::protect(repair @ %itemstring) && Flood::protect(repairdone @ %itemstring))
        {
            if(!$Announce::Filter)
                say(1, sprintf($Announce::RepairBegun::string, %itemstring) @ Announce::getJob(%itemroot));
        }
    }
    return;
}


function Announce::getJob(%item)
{
    if(String::findSubStr(%item, "Vehicle Pad") != -1)
        return "~job:iam-rep-vpad";
    else if(String::findSubStr(%item, "Turret") != -1)
        return "~job:iam-rep-tur";
    else if(String::findSubStr(%item, "Generator") != -1)
        return "~job:iam-rep-gen";
    else if(String::findSubStr(%item, "Solar Panel") != -1)
        return "~job:iam-rep-gen";
    else if(String::findSubStr(%item, "Motion Sensor") != -1)
        return "~job:iam-rep-deps";
    else if(String::findSubStr(%item, "Pulse Sensor") != -1)
        return "~job:iam-rep-deps";
    else if(String::findSubStr(%item, "Sensor Jammer") != -1)
        return "~job:iam-rep-deps";
    else if(String::findSubStr(%item, "Remote") != -1)
        return "~job:iam-rep-deps";
    else if(String::findSubStr(%item, "Camera") != -1)
        return "~job:iam-rep-deps";
    else if(String::findSubStr(%item, "Station") != -1)
        return "~job:iam-rep-stat";
    else if(String::findSubStr(%item, "Ammo") != -1)
        return "~job:iam-rep-stat";
    else if(String::findSubStr(%item, "Inventory") != -1)
        return "~job:iam-rep-stat";
    else
        return "~job:iam-rep";
}


function Announce::onRepairStopped(%itemstring, %itemroot)
{
    // Turn on flood protection for this item
    Flood::protect("repair" @ %itemstring, $Announce::RepairStopped::FloodTime);

    if($Announce::RepairingPlayer) // we were repairing another player
    {
        if(Flood::protect(repairplayer @ %itemstring, 5))
        {
            if($Announce::HoldPositionMessage && !$Modifier::Pressed[$Announce::OverrideHoldKey])
                say(1, sprintf($Announce::HoldPosition::string, %itemstring));

            if($Announce::HoldPositionSound)
                localMessage("wait1");
        }
        $Announce::RepairingPlayer = false;
    }
    return;
}


function Announce::onPowerRepaired(%itemstring, %itemroot)
{
    if($Modifier::Pressed[$Announce::OverrideHoldKey])
        return;

    say(1, $Announce::PowerRepaired::string);

    return;
}


function Announce::onRepairDone(%itemstring, %itemroot)
{
    if($Modifier::Pressed[$Announce::OverrideHoldKey])
        return;

    if($Announce::RepairingPlayer) // we were repairing another player
    {
        $Announce::RepairingPlayer = false;
        return;
    }

    if(Flood::protect("repairdone" @ %itemroot, $Announce::RepairDone::FloodTime))
    {
        // Tell the team what you've repaired:
        if(!$Announce::Filter)
            say(1, sprintf($Announce::RepairDone::string, %itemstring));
    }
    return;
}


function Announce::FilterMode::Toggle()
{
    remoteBP(2048, "<L5>Repair Item Message Filter " @ wif($Announce::FilterRepairs = !$Announce::FilterRepairs, "ON", "OFF"), 4);
}


// Notify your teammates when you learn a station is down and you aren't
// carrying a Repair Pack or Engineer Repair-Gun
//
function Announce::onStationDisabled()
{
    if($Modifier::Pressed[$Announce::OverrideHoldKey])
        return;

    if((getMountedItem(1) != $Inv::Repair_Pack) && !getItemCount("Engineer Repair-Gun"))
    {
        // Tell teammates a station is down if you haven't already done so in the last 30 seconds
        if(Flood::protect("Unit is disabled", 30))
            say(1, $Announce::StationIsDown::string); // only visible to teammates
    }
    return;
}



// Notify team whenever you change armor
//
function Announce::ArmorChange()
{
    if($Modifier::Pressed[$Announce::OverrideHoldKey])
        return;

   %armortype = %armorname = "";

    // What armor are we wearing?
    for(%i = $Inv::ArmorCount; %i > 0; %i--)
    {
        if(getItemCount(%armorname = $Inv::Name[%armortype = $Inv::ArmorList[%i]]))
            break;
    }

    if(($Announce::prevArmor != %armortype) || (($FastFaves::loadname != "") && ($FastFaves::loadname != $Announce::prevLoadout)))
    {
        $Announce::prevArmor = %armortype;
        $Announce::prevLoadout = $FastFaves::loadname;
        schedule::add("say(1, \"Wearing " @ %armorname @ wif($FastFaves::loadname == "", "", " - " @ $FastFaves::loadname) @ "\");", 3.0, wearing_armor_message);
    }

    return;
}


function Announce::Carrying::Toggle()
{
    remoteBP(2048, "<L5>Announce carrying <f2>" @ wif($Announce::Carrying = !$Announce::Carrying, "ON", "OFF"),4);

    if($Announce::Carrying)
        announce::init();
    else
        Event::Attach(eventExitStation, "Announce::Carrying();");
}


function Announce::ArmorChange::Toggle()
{
    remoteBP(2048, "<L5>Announce wearing armor <f2>" @ wif($Announce::ArmorChange = !$Announce::ArmorChange, "ON", "OFF"),4);

    if($Announce::ArmorChange)
        announce::init();
    else
        Event::Attach(eventExitStation, "Announce::ArmorChange();");
}


function Announce::Deployed::Toggle()
{
    remoteBP(2048, "<L5>Announce deployed <f2>" @ wif($Announce::Deployed = !$Announce::Deployed, "ON", "OFF"),4);

    if($Announce::Deployed)
        announce::init();
    else
        Event::Detach(eventDeployed, Announce::onDeployed);
}

function announce::save()
{
    AddExportText("    // Key you can hold to prevent any anouncements");
    AddExportText("    // I recommend using a modifier like \"lshift\" for this");
    ExportSetting("    $Announce::OverrideHoldKey", "");
    AddExportText("");
    AddExportText("");
    AddExportText("// -- Armor:");
    AddExportText("");
    AddExportText("");
    AddExportText("    // Announce what armor you're wearing after you exit an inventory station");
    AddExportText("    // and you're wearing different armor or carrying a different loadout");
    ExportSetting("    $Announce::ArmorChange", true);
    AddExportText("");
    AddExportText("    // Toggle ArmorChange on/off from within Tribes");

    ExportBind("Announce::ArmorChange::Toggle();", "//bind(keyboard0, make, alt, \"whatever\", TO, \"Announce::ArmorChange::Toggle();\");");
    ExportBind("Announce::ArmorChange::Toggle_break", "//bind(keyboard0, break, alt, \"whatever\", TO, \"\", Announce::ArmorChange::Toggle_break);");

    AddExportText("");
    AddExportText("");
    AddExportText("// -- Carrying:");
    AddExportText("");
    AddExportText("");
    AddExportText("    // Announce what you're carrying when you exit a station");
    ExportSetting("    $Announce::Carrying", true);
    AddExportText("");
    AddExportText("    // Messages (including ~job: strings for Presto's TeamHUD) to be used when");
    AddExportText("    // you exit an inventory station carrying the specified item -- use \"mute\"");
    AddExportText("    // if you don't want to say anything when you're carrying that item");

    if(!ExportIndexed("    Announce::Carrying(%1, %2);", "$Announce::Carrying[%1]", "$Announce::Carrying::index[%1]", 1, $Announce::Carrying::count))
    {
        AddExportText("    Announce::Carrying(\"Turret\", \"Deploying Turrets~job:iam-depl-dtur\");");
        AddExportText("    Announce::Carrying(\"Inventory Station\", \"Carrying an Inventory Station~job:iam-depl-dinv\");");
        AddExportText("    Announce::Carrying(\"Ammo Station\", \"Carrying an Ammo Station~job:iam-depl-dammo\");");
        AddExportText("    Announce::Carrying(\"Motion Sensor\", \"Deploying Sensors~job:iam-depl-dsen\");");
        AddExportText("    Announce::Carrying(\"Pulse Sensor\", \"Deploying Sensors~job:iam-depl-dsen\");");
        AddExportText("    Announce::Carrying(\"Sensor Jammer\", \"Deploying Jammers~job:iam-depl-djam\");");
        AddExportText("    Announce::Carrying(\"Camera\", \"Deploying Cameras~job:iam-depl-dcam\");");
        AddExportText("    Announce::Carrying(\"Energy Pack\", mute);");
        AddExportText("    Announce::Carrying(\"Ammo Pack\", mute);");
        AddExportText("    Announce::Carrying(\"Shield Pack\", mute);");
        AddExportText("    Announce::Carrying(\"Sensor Jammer Pack\", mute);");
    }

    AddExportText("");
    AddExportText("    // Announce you're carrying any other items (that you haven't listed above)");
    ExportSetting("    $Announce::CarryingOther", false);
    AddExportText("");
    AddExportText("    // Number of seconds before you announce you're carrying the same thing");
    ExportSetting("    $Announce::Carrying::FloodTime", 45);
    AddExportText("");
    AddExportText("    // Toggle Announce Carrying on/off from within Tribes");

    ExportBind("Announce::Carrying::Toggle();", "//bind(keyboard0, make, alt, \"whatever\", TO, \"Announce::Carrying::Toggle();\");");
    ExportBind("Announce::Carrying::Toggle_break", "//bind(keyboard0, break, alt, \"whatever\", TO, \"\", Announce::Carrying::Toggle_break);");

    AddExportText("");
    AddExportText("");
    AddExportText("// -- Deployed:");
    AddExportText("");
    AddExportText("");
    AddExportText("    // Announce what you've deployed");
    ExportSetting("    $Announce::Deployed", true);
    AddExportText("");
    AddExportText("    // Messages (including ~job: strings for Presto's TeamHUD) to be used when you deploy the specified item");

    if(!ExportIndexed("    Announce::Deployed(%1, %2);", "$Announce::Deployed[%1]", "$Announce::Deployed::index[%1]", 1, $Announce::Deployed::count))
    {
        AddExportText("    Announce::Deployed(\"Inventory Station\", \"Inventory Station deployed~job:fin-depl-dinv\");");
        AddExportText("    Announce::Deployed(\"Ammo Station\", \"Ammo Station deployed~job:fin-depl-dammo\");");
    }

    AddExportText("");
    AddExportText("    // Announce you're deploying any other items (that you haven't listed above)");
    ExportSetting("    $Announce::DeployedOther", true);
    AddExportText("");
    AddExportText("    // Time in seconds before you announce you're deploying the same thing");
    ExportSetting("    $Announce::Deployed::FloodTime", 30);
    AddExportText("");
    AddExportText("    // Toggle Announce Deployed on/off from within Tribes");

    ExportBind("Announce::Deployed::Toggle();", "//bind(keyboard0, make, alt, \"whatever\", TO, \"Announce::Deployed::Toggle();\");");
    ExportBind("Announce::Deployed::Toggle_break", "//bind(keyboard0, break, alt, \"whatever\", TO, \"\", Announce::Deployed::Toggle_break);");

    AddExportText("");
    AddExportText("");
    AddExportText("// -- Thanks:");
    AddExportText("");
    AddExportText("");
    AddExportText("    // Say a thank you message when repaired");
    ExportSetting("    $Announce::ThankYouMessage", false);
    AddExportText("");
    AddExportText("    // Play the local sound \"Thanks\" when repaired");
    ExportSetting("    $Announce::ThankYouSound", true);
    AddExportText("");
    AddExportText("    // Delay, in seconds, before saying thanks when repaired");
    ExportSetting("    $Announce::ThankYouDelay", 1);
    AddExportText("");
    AddExportText("");
    AddExportText("// -- Stations:");
    AddExportText("");
    AddExportText("");
    AddExportText("    // Report damaged stations");
    ExportSetting("    $Announce::StationIsDown", true);
    AddExportText("");
    AddExportText("    // Message used when you try to access a damaged station");
    ExportSetting("   $Announce::StationIsDown::string", "Stations need repairs!~job:need-rep-stat~wneedrep");
    AddExportText("");
    AddExportText("");
    AddExportText("// -- Power:");
    AddExportText("");
    AddExportText("");
    AddExportText("    // Report power outtages");
    ExportSetting("    $Announce::PowerIsDown", true);
    AddExportText("");
    AddExportText("    // Message used when you try to access a station and the power is down");
    ExportSetting("    $Announce::PowerIsDown::string", "Our Power is Down!~job:need-rep-gen~wneedrep");
    AddExportText("");
    AddExportText("    // Message used when you manually trigger the PowerRestored event");
    ExportSetting("    $Announce::PowerRestored::string", "Our Power is Back Up!~wcheer1");
    AddExportText("");
    AddExportText("    // Message used when you complete repairs to a generator or solar panel");
    AddExportText("    // and the power was down");
    ExportSetting("    $Announce::PowerRepaired::string", "Our Power is Back Up!~wcheer1");
    AddExportText("");
    AddExportText("    // Say a thank you message when someone else announces they've restored power");
    ExportSetting("    $Announce::ThankPowerFixers", false);
    AddExportText("");
    AddExportText("    // Message used when someone else announces repairs to solar panel or gens");
    ExportSetting("    $Announce::ThankPowerFixers::string", "Thanks for restoring power!~wthanks");
    AddExportText("");
    AddExportText("    // Automatically trigger eventPowerRestored when you enter a station after");
    AddExportText("    // the power has been restored.");
    ExportSetting("    $Announce::AutoTriggerPowerRestored", false);
    AddExportText("");
    AddExportText("    // Message used when you access a station and the power has been restored");
    ExportSetting("    $Announce::AutoPowerRestored::string", "Our Power is Back Up!~wthanks");
    AddExportText("");
    AddExportText("    // Manually trigger eventPowerRestored and tell your teammates the power is back up");

    ExportBind("Announce::PowerRestored();", "//bind(keyboard0, make, alt, \"r\", TO, \"Announce::PowerRestored();\");");
    ExportBind("Announce::PowerRestored", "//bind(keyboard0, break, alt, \"r\", TO, \"\", Announce::PowerRestored);");

    AddExportText("");
    AddExportText("");
    AddExportText("// -- Repairs:");
    AddExportText("");
    AddExportText("");
    AddExportText("    // Don't inform your team about repairing certain (\"filtered\") items");
    ExportSetting("    $Announce::FilterRepairs", true);
    AddExportText("");
    AddExportText("    // Keep quiet about repairs on these (\"filtered\") items");

    if(!ExportIndexed("    Announce::FilterItem(%1);", "$Announce::FilterItem[%1]", "$Announce::FilterItem::index[%1]", 1, $Announce::FilterItem::count))
    {
        AddExportText("    Announce::FilterItem(\"Scout\");");
        AddExportText("    Announce::FilterItem(\"LPC\");");
        AddExportText("    Announce::FilterItem(\"HPC\");");
    }

    AddExportText("");
    AddExportText("    // Same as above, but allows you to filter based on partial strings");

    if($Announce::FilterAnyNameWith::count)
    {
        for(%i = 0; %i < $Announce::FilterAnyNameWith::count; %i++)
        {
            AddExportText("    Announce::FilterAnyNameWith(\"" @ escapestring($Announce::FilterAnyNameWith[%i]) @ "\");");
        }
    }
    else
    {
        AddExportText("    Announce::FilterAnyNameWith(\"remote\"); // filters any item with \"remote\" in the name");
        AddExportText("    Announce::FilterAnyNameWith(\"RMT\"); // filters any item with \"RMT\" in the name");
    }

    AddExportText("");
    AddExportText("    // Notify your team on beginning repairs");
    ExportSetting("    $Announce::RepairBegun", true);
    AddExportText("");
    AddExportText("    // Message used when you begin repairs");
    AddExportText("    // Use %1 for the name of the item you're repairing");
    ExportSetting("    $Announce::RepairBegun::string", "Repair begun on %1");
    AddExportText("");
    AddExportText("    // Notify your team on completing repairs");
    ExportSetting("    $Announce::RepairDone", true);
    AddExportText("");
    AddExportText("    // Seconds before you'll announce beginning repairs on the same thing");
    AddExportText("    // after a repair is interrupted");
    ExportSetting("    $Announce::RepairStopped::FloodTime", 30);
    AddExportText("");
    AddExportText("    // Seconds before you'll announce completing repairs on the same thing");
    ExportSetting("    $Announce::RepairDone::FloodTime", 30);
    AddExportText("");
    AddExportText("    // Message used when you complete repairs on an item.");
    AddExportText("    // Use %1 for the name of the item you've repaired");
    ExportSetting("    $Announce::RepairDone::string", "%1 has been repaired!~job:fin-rep");
    AddExportText("");
    AddExportText("    // Tell an antsy teammate to sit still for repairs");
    ExportSetting("    $Announce::HoldPositionMessage", false);
    AddExportText("");
    AddExportText("    // Play the local sound \"wait\" to tell an antsy teammate to sit still for repairs");
    ExportSetting("    $Announce::HoldPositionSound", true);
    AddExportText("");
    AddExportText("    // Message used when a player you're repairing moves, interrupting the repair.");
    AddExportText("    // Use %1 for the name of the player you're repairing");
    ExportSetting("    $Announce::HoldPosition::string", "%1, hold position to be repaired.");
    AddExportText("");
    AddExportText("    // Toggle repair message filtering on/off");

    ExportBind("Announce::FilterMode::Toggle();", "//bind(keyboard0, make, alt, \"whatever\", TO, \"Announce::FilterMode::Toggle();\");");
    ExportBind("Announce::FilterMode::Toggle_break", "//bind(keyboard0, break, alt, \"whatever\", TO, \"\", Announce::FilterMode::Toggle_break);");
}

WriterPrefs::save("announce");

function announce::init()
{
    needs("writer\\announce.cs", "writer\\event.cs 2.7",
                                 "writer\\flood.cs 1.3",
                                 "writer\\inventory.cs 3.3",
                                 "writer\\modifier.cs 2.5",
                                 "writer\\repair_events.cs 1.3",
                                 "writer\\save.cs 2.3",
                                 "writer\\schedule.cs 1.3",
                                 "writer\\station_events.cs 4.8",
                                 "writer\\whatif.cs 1.1");

    if(String::Compare($Announce::OverrideHoldKey, ""))
        Modifier::bind($Announce::OverrideHoldKey);

    if($Announce::Carrying)
        Event::Attach(eventExitStation, "Announce::Carrying();");

    if($Announce::Deployed)
        Event::Attach(eventDeployed, Announce::onDeployed);

    if($Announce::StationIsDown)
        Event::Attach(eventStationDisabled, "Announce::onStationDisabled();");

    if($Announce::PowerIsDown)
        Event::Attach(eventPowerIsDown, "Announce::onPowerIsDown();");

    if($Announce::PowerRepaired)
        Event::Attach(eventPowerRepaired, Announce::onPowerRepaired);

    if($Announce::AutoTriggerPowerRestored)
    {
        Event::Attach(eventPowerRestored, "Announce::onPowerRestored();");
        Event::Attach(eventRemoteInventoryStation, "Announce::onRemoteInventoryStation();");
    }

    if($Announce::ThankPowerFixers)
        Event::Attach(eventOtherPlayerRestoredPower, Announce::onOtherPlayerRestoredPower);

    if($Announce::RepairBegun || $Announce::RepairDone)
        Event::Attach(eventRepairBegun, Announce::onRepairBegun);

    if($Announce::RepairDone)
        Event::Attach(eventRepairDone, Announce::onRepairDone);

    Event::Attach(eventRepairStopped, Announce::onRepairStopped);

    Event::Attach(eventRepairingPlayer, "$Announce::RepairingPlayer=true;");

    if($Announce::ArmorChange)
    {
        Event::Attach(eventExitStation, "Announce::ArmorChange();");
        Event::Attach(eventEnterStation, "schedule::cancel(wearing_armor_message);");
    }

    if($Announce::ThankYouMessage || $Announce::ThankYouSound)
        Event::Attach(eventBeingRepairedBy, Announce::onBeingRepairedBy);
}
Event::Attach(writerInit, "announce::init();");

if(!$UsingWriterLoader) announce::init();
